/*======================================================================================================================
 *      File: macros.h
 *   Project: Parts Scale
 * Processor: ATtiny85
 * Frequency: 16.5 Mhz
 *    Author: eX Systems
 *     Email: jaredjulien@exsystems.net
 * Copyright: (c) 2018 eX Systems
 *
 * --------------------------------------------------------------------------------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
 * documentation files (the "Software"), to deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
 * OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * --------------------------------------------------------------------------------------------------------------------
 *
 * Date        Rev   Author    Change Description
 * ==========  ====  ========  ========================================================================================
 * 2018-02-11  1     Jared     Initial file creation based upon USB ignition switch project
 * --------------------------------------------------------------------------------------------------------------------
 */
#ifndef MACROS_H
#define MACROS_H

#define bs(b) (1<<(b))
#define sbi(p, b) ((p)|=bs(b))
#define cbi(p, b) ((p)&=(~bs(b)))

#define abs(x) ((x) > 0 ? (x) : (-x))
#define constrain(x, y, z) (((x)<(y))?(y):(((x)>(z))?(z):(x)))

#endif /* MACROS_H */
